freeslot("sfx_wodlnd", "sfx_cnclnd", "sfx_drtlnd", "sfx_mtllnd", "sfx_grslnd", "sfx_wtrlnd", "sfx_wtrbrk", "sfx_watr1", "sfx_watr2", "sfx_watr3", "sfx_watr4", "sfx_watr5", "sfx_grsbrk", "sfx_mtlbrk", "sfx_wodbrk", "sfx_cncbrk", "sfx_drtbrk", "sfx_wood1", "sfx_wood2", "sfx_wood3", "sfx_wood4", "sfx_wood5", "sfx_dirt1", "sfx_dirt2", "sfx_dirt3", "sfx_dirt4", "sfx_dirt5", "sfx_conct1", "sfx_conct2", "sfx_conct3", "sfx_conct4", "sfx_conct5", "sfx_grass1", "sfx_grass2", "sfx_grass3", "sfx_grass4", "sfx_grass5", "sfx_metal1", "sfx_metal2", "sfx_metal3", "sfx_metal4", "sfx_metal5", "sfx_glss1", "sfx_glss2", "sfx_glss3", "sfx_glslnd", "sfx_glsbrk")

S_sfx[sfx_grslnd] = {false, 64, SF_NOMULTIPLESOUND}
S_sfx[sfx_mtllnd] = {false, 64, SF_NOMULTIPLESOUND}
S_sfx[sfx_drtlnd] = {false, 64, SF_NOMULTIPLESOUND}
S_sfx[sfx_cnclnd] = {false, 64, SF_NOMULTIPLESOUND}
S_sfx[sfx_wodlnd] = {false, 64, SF_NOMULTIPLESOUND}
S_sfx[sfx_wtrlnd] = {false, 64, SF_NOMULTIPLESOUND}

rawset(_G, "GetGroundTexture", function(mo)
    local result = nil
    
    if mo.eflags & MFE_VERTICALFLIP
		if mo.ceilingrover
			result = mo.ceilingrover.bottompic
        elseif mo.standingslope and mo.standingslope == mo.subsector.sector.c_slope
            result = mo.subsector.sector.ceilingpic
        elseif mo.ceilingz == mo.subsector.sector.ceilingheight
            result = mo.subsector.sector.ceilingpic
		end
    else
        if mo.floorrover
            result = mo.floorrover.toppic
		elseif mo.standingslope and mo.standingslope == mo.subsector.sector.f_slope
            result = mo.subsector.sector.floorpic
        elseif mo.floorz == mo.subsector.sector.floorheight
			result = mo.subsector.sector.floorpic
        end
	end
	
	return result
end)

local soundsList = {
    ["grass"] = {
      ["steps"] = {sfx_grass1, sfx_grass2, sfx_grass3, sfx_grass4, sfx_grass5},
      ["skid"] = {sfx_grsbrk},
      ["land"] = {sfx_grslnd},
    },
    ["metal"] = {
      ["steps"] = {sfx_metal1, sfx_metal2, sfx_metal3, sfx_metal4, sfx_metal5},
      ["skid"] = {sfx_mtlbrk},
      ["land"] = {sfx_mtllnd},
    },
    ["dirt"] = {
      ["steps"] = {sfx_dirt1, sfx_dirt2, sfx_dirt3, sfx_dirt4, sfx_dirt5},
      ["skid"] = {sfx_drtbrk},
      ["land"] = {sfx_drtlnd},
    },
    ["wood"] = {
      ["steps"] = {sfx_wood1, sfx_wood2, sfx_wood3, sfx_wood4, sfx_wood5},
      ["skid"] = {sfx_wodbrk},
      ["land"] = {sfx_wodlnd},
    },
    ["concrete"] = {
      ["steps"] = {sfx_conct1, sfx_conct2, sfx_conct3, sfx_conct4, sfx_conct5},
      ["skid"] = {sfx_cncbrk},
      ["land"] = {sfx_cnclnd},
    },
    ["water"] = {
      ["steps"] = {sfx_watr1, sfx_watr2, sfx_watr3, sfx_watr4, sfx_watr5},
      ["skid"] = {sfx_wtrbrk},
      ["land"] = {sfx_wtrlnd},
    },
    ["glass"] = {
      ["steps"] = {sfx_glss1, sfx_glss2, sfx_glss3},
      ["skid"] = {sfx_glsbrk},
      ["land"] = {sfx_glslnd},
	},
}

if not FlatSounds
  rawset(_G, "FlatSounds", {})
end

local flatsounds = { 
	["GFZROCKC"] = "concrete",
	["OLDGFZF1"] = "dirt",
	["OLDGFZF2"] = "grass",
	["OLDGFZF3"] = "grass",
	["OLDGFZF4"] = "concrete",
	["GFZROCKA"] = "concrete",
	["GFZWAVEF"] = "concrete",
	["GFZFNCG"] = "wood",
	["GFZFNCF"] = "wood",
	["GFZFLR01"] = "concrete",
	["GFZFLR02"] = "grass",
	["GFZFLR03"] = "metal",
	["GFZFLR04"] = "metal",
	["GFZFLR05"] = "wood",
	["GFZFLR06"] = "wood",
	["GFZFLR07"] = "wood",
	["GFZFLR08"] = "dirt",
	["GFZFLR09"] = "wood",
	["GFZFLR10"] = "grass",
	["GFZFLR11"] = "concrete",
	["GFZFLR12"] = "concrete",
	["GFZFLR13"] = "wood",
	["GFZFLR14"] = "concrete",
	["GFZFLR15"] = "concrete",
	["GFZFLR16"] = "concrete",
	["GFZFLR17"] = "concrete",
	["GFZFLR18"] = "wood",
	["GFZFLR19"] = "wood",
	["GFZFLR20"] = "concrete",
	["GFZFLR21"] = "grass",
	["GFZFLR22"] = "grass",
	["GFZROCK"] = "concrete",
	["GFZGRSW"] ="grass",
	["THCOMPF1"] = "metal",
	["THCOMPF2"] = "metal",
	["THCOMPF3"] = "metal",
	["THCOMPF4"] = "metal",
	["THCOMPF5"] = "metal",
	["THCOMPF6"] = "metal",
	["THZGRS1"] = "grass",
	["THZGRS2"] = "grass",
	["TH2_SF1"] = "concrete",
	["TH2_SF2"] = "concrete",
	["TH2_SF3"] = "concrete",
	["COMP7A"] = "metal",
	["COMP7B"] = "metal",
	["THZELA1"] = "metal",
	["THZELA2"] = "metal",
	["THZELB1"] = "metal",
	["THZELB2"] = "metal",
	["THZELC1"] = "metal",
	["THZELC2"] = "metal",
	["THZELD1"] = "metal",
	["THZELD2"] = "metal",
	["THZELE1"] = "metal",
	["THZELE2"] = "metal",
	["THZELF1"] = "metal",
	["THZELF2"] = "metal",
	["THZELG1"] = "metal",
	["THZELG2"] = "metal",
	["THZELH1"] = "metal",
	["THZELH2"] = "metal",
	["THZELI1"] = "metal",
	["THZELI2"] = "metal",
	["THZELJ1"] = "metal",
	["THZELJ2"] = "metal",
	["THZFLR35"] = "metal",
	["THZFLR36"] = "metal",
	["THZREDP1"] = "metal",
	["THZREDP2"] = "metal",
	["THZGRYP1"] = "metal",
	["THZGRYP2"] = "metal",
	["F_METAL1"] = "metal",
	["F_METAL2"] = "metal",
	["THZ2FN1"] = "concrete",
	["THZ3DPF1"] = "concrete",
	["THZ3DPF2"] = "concrete",
	["THZ3DPF3"] = "concrete",
	["THZ3DPF4"] = "concrete",
	["THZ3DPFA"] = "metal",
	["THZ3DPFB"] = "metal",
	["THZ3DPFC"] = "metal",
	["THZ3DPFD"] = "metal",
	["THPIPEF1"] = "metal",
	["THPIPEF2"] = "metal",
	["STKBOXS1"] = "metal",
	["STKBOXS2"] = "metal",
	["STKBOXS3"] = "metal",
	["STKBOXS4"] = "metal",
	["STKBOXT1"] = "metal",
	["STKBOXT2"] = "metal",
	["STKBOXT3"] = "metal",
	["STKBOXT4"] = "metal",
	["STKBOXK1"] = "metal",
	["STKBOXK2"] = "metal",
	["STKBOXK3"] = "metal",
	["STKBOXK4"] = "metal",
	["THZBOX"] = "metal",
	["THZBOXF1"] = "metal",
	["THZBOXF2"] = "metal",
	["THZBOXF3"] = "metal",
	["THZBOXF4"] = "metal",
	["THZFLR01"] = "metal",
	["THZFLR02"] = "metal",
	["THZFLR03"] = "metal",
	["THZFLR04"] = "metal",
	["THZFLR05"] = "metal",
	["THZFLR06"] = "metal",
	["THZFLR07"] = "metal",
	["THZFLR08"] = "metal",
	["THZFLR09"] = "metal",
	["THZFLR10"] = "metal",
	["THZFLR11"] = "metal",
	["THZFLR12"] = "metal",
	["THZFLR13"] = "metal",
	["THZFLR14"] = "metal",
	["THZFLR15"] = "metal",
	["THZFLR16"] = "metal",
	["THZFLR17"] = "metal",
	["THZFLR18"] = "metal",
	["THZFLR19"] = "metal",
	["THZFLR20"] = "metal",
	["THZFLR21"] = "metal",
	["THZFLR22"] = "metal",
	["THZFLR23"] = "metal",
	["THZFLR24"] = "metal",
	["THZFLR25"] = "metal",
	["THZFLR26"] = "metal",
	["THZFLR27"] = "metal",
	["THZFLR28"] = "metal",
	["THZFLR29"] = "metal",
	["THZFLR30"] = "concrete",
	["THZFLR31"] = "metal",
	["THZFLR32"] = "metal",
	["THZFLR33"] = "metal",
	["THZFLR34"] = "metal",
	["THZFLR35"] = "metal",
	["THZFLR36"] = "metal",
	["THZFLR37"] = "metal",
	["THZ2FN2"] = "metal",
	["THZ2FN3"] = "metal",
	["THZ2FN4"] = "metal",
	["THZ2FN4B"] = "metal",
	["THZ2FN5"] = "metal",
	["THZ2FN5B"] = "metal",
	["THZ2FN6"] = "metal",
	["THZ2FN6B"] = "metal",
	["THZ2FN7"] = "metal",
	["THZ2FN7B"] = "metal",
	["THZ2FN8"] = "metal",
	["THZ2FN9"] = "metal",
	["THZ2WN5"] = "metal",
	["THZ2WN5B"] = "metal",
	["THZ2WN6"] = "metal",
	["THZ2WN6B"] = "metal",
	["THZ2WN7"] = "metal",
	["THZ2WN7B"] = "metal",
	["THZ2WN8"] = "metal",
	["THZ2WN8B"] = "metal",
	["THZ2CN1"] = "metal",
	["THZ2CN1B"] = "metal",
	["THZ2CN2"] = "metal",
	["THZ2CN2B"] = "metal",
	["THZ2CN3"] = "metal",
	["THZ2CN3B"] = "metal",
	["THZ2CN4"] = "metal",
	["THZ2CN4B"] = "metal",
	["THZ2CN5"] = "metal",
	["THZ2CN5B"] = "metal",
	["THZ2CN6"] = "metal",
	["THZ2CN6B"] = "metal",
	["THZ2CN7"] = "metal",
	["THZ2CN7B"] = "metal",
	["THZ2CN8"] = "metal",
	["THZ2CN8B"] = "metal",
	["THZLIG1"] = "metal",
	["THZLIG2"] = "metal",
	["THZLITS"] = "metal",
	["THROCKF"] = "metal",
	["THROCKF"] = "concrete",
	["THROCKF2"] = "concrete",
	["THROCKLF"] = "concrete",
	["THTILEF1"] = "metal",
	["ALTBOXF1"] = "metal",
	["ALTBOXF2"] = "metal",
	["ALTBOXF3"] = "metal",
	["ALTBOXF4"] = "metal",
	["BOXWARN2"] = "metal",
	["BOXWARNG"] = "metal",
	["PIPE2F"] = "metal",
	["PIPE3F"] = "metal",
	["THDIRT"] = "dirt",
	["STEEL"] = "metal",
	["STEEL2"] = "metal",
	["STEEL3"] = "metal",
	["STEEL01"] = "metal",
	["STEEL02"] = "metal",
	["STEEL03"] = "metal",
	["STEEL04"] = "metal",
	["STEEL05"] = "metal",
	["STEEL06"] = "metal",
	["STEEL07"] = "metal",
	["STEEL08"] = "metal",
	["STEEL08B"] = "metal",
	["DSZ10"] = "concrete",
	["DSZ11"] = "concrete",
	["DSZFLR01"] = "concrete",
	["DSZFLR02"] = "concrete",
	["DSZFLR03"] = "concrete",
	["DSZFLR04"] = "dirt",
	["DSZFLR05"] = "dirt",
	["DSZFLR06"] = "dirt",
	["DSZFLR07"] = "concrete",
	["DSZFLR08"] = "concrete",
	["DSZFLR09"] = "concrete",
	["DSZFLR10"] = "concrete",
	["DSZFLR11"] = "concrete",
	["DSZFLR12"] = "concrete",
	["DSZFLR13"] = "concrete",
	["DSZFLR14"] = "concrete",
	["DSZFLR15"] = "concrete",
	["DSZFLR16"] = "concrete",
	["DSZFLR17"] = "concrete",
	["DSZFLR18"] = "concrete",
	["DSZFLR19"] = "concrete",
	["DSZRCKF1"] = "concrete",
	["DSZRCKF2"] = "concrete",
	["DSZRCKF3"] = "concrete",
	["DSWHEELF"] = "concrete",
	["DSBLOCK1"] = "concrete", 
	["DSBLOCK2"] = "concrete",
	["DSBLOCK3"] = "concrete", 
	["DSBLOCK4"] = "concrete",
	["DSCYAN1"] = "concrete",
	["DSCYAN3"] = "concrete",
	["DSDEBRIS"] = "concrete", 
	["DSFLOOR1"] = "concrete",
	["DSFLOOR2"] = "concrete",
	["DSKNUXB1"] = "concrete",
	["DSLTILE1"] = "concrete",
	["DSLTILE2"] = "concrete",
	["DSNOCLM2"] = "concrete",
	["DSRFLOR1"] = "concrete",
	["DSRFLOR2"] = "concrete",
	["DSROCK_1"] = "dirt",
	["DSROCK_2"] = "concrete",
	["DSSBFLR1"] = "dirt",
	["DSSBFLR2"] = "water",
	["DSSBFLR3"] = "water",
	["DSSBFLR4"] = "water",
	["DSSKSEA1"] = "water",
	["DSSKSEA2"] = "water",
	["DSSWIT1"] = "concrete",
	["DSSWIT2"] = "concrete",
	["DSSWIT3"] = "concrete",
	["DSSWIT4"] = "concrete",
	["DSSWIT5"] = "concrete",
	["DSSWIT6"] = "concrete",
	["DSTILEN1"] = "concrete",
	["DSTILE_1"] = "concrete",
	["DSTRACK1"] = "concrete",
	["DSTRACK2"] = "concrete",
	["DSWATER1"] = "water",
	["DSWATER2"] = "water",
	["CESTOND1"] = "concrete",
	["CESTOND2"] = "concrete",
	["CESTOND3"] = "concrete",
	["CESTOND4"] = "concrete",
	["CESTOND5"] = "concrete",
	["CESTOND6"] = "concrete",
	["CESTOND7"] = "concrete",
	["CESTOND8"] = "concrete",
	["CESTOND9"] = "concrete",
	["CESTONE"] = "concrete",
	["CESTONE1"] = "concrete",
	["CESTONE2"] = "concrete",
	["CESTONE3"] = "concrete",
	["CESTONE4"] = "concrete",
	["CESTONE5"] = "concrete",
	["CESTONE6"] = "concrete",
	["CESTONE7"] = "concrete",
	["CESTONE8"] = "concrete",
	["CESTONE9"] = "concrete",
	["BRIDGEA1"] = "concrete",
	["BRIDGEA2"] = "concrete",
	["BRIDGEA3"] = "concrete",
	["OLDCEZF1"] = "concrete",
	["CEBRAMBL"] = "grass",
	["CEZFLR01"] = "concrete",
	["CEZFLR02"] = "grass",
	["CEZFLR03"] = "grass",
	["CEZFLR04"] = "concrete",
	["CEZFLR05"] = "grass",
	["CEZFLR06"] = "concrete",
	["CEZFLR07"] = "wood",
	["CEZFLR08"] = "wood",
	["CEZFLR09"] = "concrete",
	["CEZFLR10"] = "wood",
	["CEZFLR11"] = "wood",
	["CEZFLR12"] = "grass",
	["CEZFLR13"] = "grass",
	["CEZROCKA"] = "concrete",
	["CEZDRTF0"] = "dirt",
	["CEZGRS0"] = "grass",
	["CEZGRS1"] = "grass",
	["CEZGRS2"] = "dirt",
	["CEZLEAF0"] = "grass",
	["CEZRCKF0"] = "concrete",
	["LIBFLR1"] = "wood",
	["LIBFLR2"] = "wood",
	["DMAFLAT1"] = "concrete",
	["DMAFLAT2"] = "concrete",
	["DMAFLAT3"] = "concrete",
	["DMAFLAT4"] = "concrete",
	["DMAFLAT5"] = "concrete",
	["DMAFLAT6"] = "concrete",
	["DMAFLAT7"] = "concrete",
	["DMAFLAT8"] = "concrete",
	["CETILE1"] = "concrete",
	["CETILE1B"] = "concrete",
	["CETILE2"] = "concrete",
	["CETILE2B"] = "concrete",
	["CETILE3"] = "concrete",
	["CETILD1"] = "concrete",
	["CETILD1B"] = "concrete",
	["CETILD2"] = "concrete",
	["CETILD2B"] = "concrete",
	["CETILD3"] = "concrete",
	["CETILC1"] = "concrete",
	["CETILC2"] = "concrete",
	["CETILB1"] = "concrete",
	["CETILB1B"] = "concrete",
	["CETILB2"] = "concrete",
	["CETILB2B"] = "concrete",
	["CETILB3"] = "concrete",
	["CASTLE2"] = "wood",
	["CASTLE3"] = "wood",
	["CASTLE4"] = "wood",
	["CASTLE5"] = "wood",
	["CASTLED"] = "wood",
	["CASTLEF"] = "wood",
	["CASTLEG"] = "wood",
	["CASTLEE"] = "wood",
	["CASTLEFF"] = "metal",
	["CEZBRWL1"] = "dirt",
	["CESBCA00"] = "concrete",
	["CESBFO01"] = "concrete",
	["CEBURST1"] = "concrete",
	["CEBURST2"] = "concrete",
	["CEBURST3"] = "concrete",
	["CEVBARF"] = "grass",
	["CESTP1E"] = "concrete",
	["CESTP1N"] = "concrete",
	["CESTP1W"] = "concrete",
	["CESTP1S"] = "concrete",
	["CECRPTR"] = "dirt",
	["CECRPTRE"] = "dirt",
	["CECRPTRS"] = "dirt",
	["CECRPTRW"] = "dirt",
	["CECRPTRN"] = "dirt",
	["CECRPTG1"] = "dirt",
	["CECRPTG2"] = "dirt",
	["CECRPTGN"] = "dirt",
	["CECRPTGS"] = "dirt",
	["CECRPTGW"] = "dirt",
	["CECRPTGE"] = "dirt",
	["CECRPTB"] = "dirt",
	["CECRPTBE"] = "dirt",
	["CECRPTBS"] = "dirt",
	["CECRPTBW"] = "dirt",
	["CECRPTBN"] = "dirt",
	["CETILL1"] = "concrete",
	["CETILL1B"] = "concrete",
	["CETILL2"] = "concrete",
	["CETILL2B"] = "concrete",
	["CETILL3"] = "concrete",
	["CETILL4"] = "concrete",
	["CETILL5"] = "concrete",
	["CETILL6"] = "concrete",
	["CEZCLOUD"] = "concrete",
	["CEZGRS10"] = "grass",
	["CEZGRS11"] = "grass",
	["CEZPLD1F"] = "dirt",
	["CEZWATR0"] = "water",
	["CEZWATR1"] = "water",
	["SLF_174"] = "concrete",
	["CETILE4"] = "concrete",
	["CETILE4B"] = "concrete",
	["CETILC4"] = "concrete",
	["CETILC4B"] = "concrete",
	["CEBUSTC1"] = "concrete",
	["CESTOND3"] = "concrete",
	["ACZWAL2"] = "concrete",
	["AC2_8_2_"] = "concrete",
	["ACDEBRIS"] = "metal",
	["ACDEBRI2"] = "metal",
	["ACMTRKF1"] = "wood",
	["ACROAD1"] = "concrete",
	["ACSBCAN1"] = "concrete",
	["ACSBCAN3"] = "concrete",
	["ACSBDSRC"] = "dirt",
	["ACSBDSRR"] = "wood",
	["ACSBDSRT"] = "dirt",
	["ACSTEAM0"] = "metal",
	["ACROCKY1"] = "concrete",
	["ACROCKY2"] = "concrete",
	["ACROCKY3"] = "concrete",
	["ACROCKY4"] = "concrete",
	["ACROCKY5"] = "concrete",
	["ACROPE1"] = "dirt",
	["ACROPE2"] = "dirt",
	["ACROPF1"] = "concrete",
	["ACROPF2"] = "concrete",
	["ACROPF3"] = "concrete",
	["ACROPF4"] = "concrete",
	["ACZBARLF"] = "metal",
	["ACZCRATF"] = "wood",
	["ACZFLR01"] = "concrete",
	["ACZFLR02"] = "concrete",
	["ACZFLR03"] = "concrete",
	["ACZFLR04"] = "wood",
	["ACZFLR05"] = "wood",
	["ACZFLR06"] = "wood",
	["ACZFLR07"] = "wood",
	["ACZFLR08"] = "wood",
	["ACZFLR09"] = "wood",
	["ACZFLR10"] = "wood",
	["ACZFLR11"] = "wood",
	["ACZFLR12"] = "metal",
	["ACZFLR13"] = "metal",
	["ACZFLR14"] = "dirt",
	["ACZFLR15"] = "dirt",
	["ACZFLR16"] = "wood",
	["ACZFLR17"] = "wood",
	["ACZFLR18"] = "wood",
	["ACZFLR19"] = "wood",
	["ACZFLR20"] = "concrete",
	["ACZFLR21"] = "concrete",
	["ACZFLR22"] = "dirt",
	["ACZFLR23"] = "dirt",
	["ACZFLR24"] = "concrete",
	["ACZFLR25"] = "concrete",
	["ACZFLR26"] = "concrete",
	["ACZFLR27"] = "concrete",
	["ACZFLR28"] = "concrete",
	["ACZRAILF"] = "metal",
	["ACZRAILP"] = "concrete",
	["ACZRFL1A"] = "concrete",
	["ACZRFL1B"] = "concrete",
	["ACZRFL1C"] = "concrete",
	["ACZRFL1D"] = "concrete",
	["ACZRFL1E"] = "concrete",
	["ACZRFL1F"] = "concrete",
	["ACZRFL1G"] = "concrete",
	["ACZRFL1H"] = "concrete",
	["ACZRFL2A"] = "concrete",	
	["ACZRFL2B"] = "concrete",
	["ACZRFL2C"] = "concrete",
	["ACZRFL2D"] = "concrete",
	["ACZRFL2E"] = "concrete",
	["ACZRFL2F"] = "concrete",
	["ACZRFL2G"] = "concrete",
	["ACZRFL2H"] = "concrete",	
	["ACZROKF1"] = "concrete",
	["ACZROKF2"] = "concrete",
	["ACZROCK3"] = "concrete",
	["ACWOODS1"] = "wood",
	["ACWOODS2"] = "wood",
	["ACWOOD1F"] = "wood",
	["ACWOOD2F"] = "wood",
	["ACWOOD3F"] = "wood",
	["ACWOOD4F"] = "wood",
	["ACWOODBX"] = "wood",
	["FACSB_3"] = "dirt",
	["FACSB_4"] = "grass",
	["RVZWALF1"] = "concrete",
	["RVZWALF2"] = "concrete",
	["RVZWALF3"] = "concrete",
	["RVZWALF4"] = "concrete",
	["RVZWALF5"] = "concrete",
	["RVZWALF6"] = "concrete",
	["RVZWALF7"] = "concrete",
	["MMFLR7"] = "concrete",
	["MMFLR8"] = "concrete",
	["MMFLR9"] = "concrete",
	["MMFLRA"] = "concrete",
	["MMFLRB2"] = "concrete",
	["MMFLRB3"] = "concrete",
	["MMFLRB4"] = "concrete",
	["MMFLRB5"] = "concrete",
	["MMFLRB5A"] = "concrete",
	["MMFLRB6"] = "concrete",
	["MMFLRB7"] = "concrete",
	["MMFLRB8"] = "concrete",
	["MMFLRD"] = "concrete",
	["MMFLRE"] = "concrete",
	["MMFLRF"] = "concrete",
	["FLOOR6_2"] = "concrete",
	["MINECRAT"] = "concrete",
	["TLITE6_1"] = "concrete",
	["TLITE6_5"] = "concrete",
	["TLITE6_6"] = "concrete",
	["RVZDRUMT"] = "concrete",
	["RVZGRS01"] = "grass",
	["RVZGRS02"] = "grass",
	["RVZGRS03"] = "grass",
	["RVZGRS04"] = "grass",
	["RVZGRS05"] = "grass",
	["RVZGRS06"] = "grass",
	["RVZGRS07"] = "grass",
	["RVZ2STOP"] = "concrete",
	["RVZ2SBTM"] = "concrete",
	["RVZ1SBTM"] = "concrete",
	["FRSTRCKF"] = "concrete",
	["MMBFLR9"] = "concrete",
	["MMBFLRA"] = "concrete",
	["MMBFLRB"] = "concrete",
	["MMBFLRC"] = "concrete",
	["RVDARKF1"] = "concrete",
	["RVDARKF2"] = "concrete",
	["RVPUMICF"] = "concrete",
	["RVRCKTTO"] = "concrete",
	["RVZ1S_BF"] = "water",
	["ERZBGF3"] = "metal",
	["EGRIDF1"] = "metal",
	["EGRIDF2"] = "metal",
	["EGRIDF3"] = "metal",
	["ERZBGF2"] = "metal",
	["ERZBGF5"] = "metal",
	["ERZBGF6"] = "metal",
	["ERZBLUF2"] = "metal",
	["ERZBLUF3"] = "metal",
	["ERZBLUF4"] = "metal",
	["ERZFAN1"] = "metal",
	["ERZFAN2"] = "metal",
	["ERZFAN3"] = "metal",
	["ERZFAN4"] = "metal",
	["ERZFANR1"] = "metal",
	["ERZFANR2"] = "metal",
	["ERZFANR3"] = "metal",
	["ERZFANR4"] = "metal",
	["ERZFLR00"] = "metal",
	["ERZFLR01"] = "metal",
	["ERZFLR02"] = "metal",
	["ERZFLR03"] = "metal",
	["ERZFLR04"] = "metal",
	["ERZFLR05"] = "metal",
	["ERZFLR06"] = "metal",
	["ERZFLR07"] = "metal",
	["ERZFLR08"] = "metal",
	["ERZFLR09"] = "metal",
	["ERZFLR10"] = "metal",
	["ERZFLR11"] = "metal",
	["ERZGREYF"] = "metal",
	["ERZGRYF2"] = "metal",
	["ERZGRYF3"] = "metal",
	["ERZGRYF4"] = "metal",
	["ERZMASH1"] = "metal",
	["ERZMASH2"] = "metal",
	["ERZMASH3"] = "metal",
	["ERZMASH4"] = "metal",
	["ERZMASH5"] = "metal",
	["ERZMASH6"] = "metal",
	["ERZMASH7"] = "metal",
	["ERZMASH8"] = "metal",
	["ERZPLTF1"] = "metal",
	["ERZPLTF2"] = "metal",
	["ERZPLTF3"] = "metal",
	["ERZPLTF4"] = "metal",
	["ERZPLTF5"] = "metal",
	["ERZPLTF6"] = "metal",
	["ERZRCKF1"] = "concrete",
	["ERZRCKF2"] = "concrete",
	["ERZRCKF3"] = "concrete",
	["ERZRCKF4"] = "concrete",
	["ERZRCKF5"] = "concrete",
	["ERZRCKF6"] = "dirt",
	["ERZRCKF7"] = "concrete",
	["ERZRCKF8"] = "concrete",
	["ERZRCKF9"] = "concrete",
	["ERZREDF2"] = "metal",
	["ERZREDF3"] = "metal",
	["ERZREDF4"] = "metal",
	["ERZREDF5"] = "metal",
	["ERFANFL1"] = "metal",
	["ERFANFL2"] = "metal",
	["ERFANFL3"] = "metal",
	["ERLAVA1"] = "water", 
	["ERZFLR13"] = "metal",
	["ERZFLR14"] = "metal",
	["ERZRCKF7"] = "dirt",
	["ERZAI200"] = "concrete",
	["ERZAI201"] = "concrete",
	["ERZAI202"] = "concrete",
	["ERZAI203"] = "concrete",
	["ERZAI204"] = "concrete",
	["ERZAI205"] = "concrete",
	["ERZAI206"] = "concrete",
	["ERZAI207"] = "concrete",
	["ERZAI208"] = "concrete",
	["ERZAI209"] = "concrete",
	["ERZAI210"] = "concrete",
	["ERZAI211"] = "concrete",
	["ERZAI212"] = "concrete",
	["ERZAI213"] = "concrete",
	["ERZAI214"] = "concrete",
	["ERZAI215"] = "concrete",
	["ERZAIR00"] = "concrete",
	["ERZAIR01"] = "concrete",
	["ERZAIR02"] = "concrete",
	["ERZAIR03"] = "concrete",
	["ERZAIR04"] = "concrete",
	["ERZAIR05"] = "concrete",
	["ERZAIR06"] = "concrete",
	["ERZAIR07"] = "concrete",
	["ERZAIR08"] = "concrete",
	["ERZAIR09"] = "concrete",
	["ERZAIR10"] = "concrete",
	["ERZAIR11"] = "concrete",
	["ERZAIR12"] = "concrete",
	["ERZAIR13"] = "concrete",
	["ERZAIR14"] = "concrete",
	["ERZAIR15"] = "concrete",
	["ERZBGF1"] = "metal",
	["ERZBGF4"] = "metal",
	["ERZBLUF1"] = "metal",
	["ERZBLUF5"] = "metal",
	["ERZCRTF1"] = "metal",
	["ERZFLR12"] = "metal",
	["ERZGRYF1"] = "metal",
	["ERZLITF2"] = "metal",
	["ERZPI2F1"] = "metal",
	["ERZPIPF1"] = "metal",
	["ERZPIPF2"] = "metal",
	["ERZPIPF5"] = "metal",
	["ERZPIPF6"] = "metal",
	["ERZPIPF8"] = "metal",
	["ERZREDF1"] = "metal",
	["ERZPIPF3"] = "metal",
	["ERZPIPF9"] = "metal",
	["ERZGRYF5"] = "metal",
	["ERZGRTF1"] = "metal",
	["ERZWRNF1"] = "metal",
	["DCZFLR01"] = "concrete",
	["DCZFLR02"] = "metal",
	["DCZFLR03"] = "concrete",
	["DCZFLR04"] = "concrete",
	["DCZFLR05"] = "concrete",
	["DCZFLR06"] = "concrete",
	["DCZFLR07"] = "metal",
	["DCZFLR08"] = "metal",
	["DCZFLR09"] = "concrete",
	["DCZFLR10"] = "dirt",
	["DCZFLR11"] = "metal",
	["DCZFLR12"] = "metal",
	["DCZFLR13"] = "concrete",
	["DCZFLR14"] = "concrete",
	["DCZFLR15"] = "concrete",
	["DCZFLR16"] = "concrete",
	["DCZFLR17"] = "concrete",
	["DCFLR01"] = "concrete",
	["DCFLR02"] = "concrete",
	["DCFLR03"] = "concrete",
	["DCFLR04"] = "concrete",
	["DCFLR05"] = "concrete",
	["DCFLR06"] = "concrete",
	["DCFLR07"] = "concrete",
	["DCFLR08"] = "concrete",
	["DCFLR09"] = "concrete",
	["DCFLR10"] = "concrete",
	["DCFLR11"] = "concrete",
	["DCFLR12"] = "concrete",
	["DCFLR13"] = "concrete",
	["DCFLR14"] = "concrete",
	["DCFLR15"] = "concrete",
	["DCFLR16"] = "concrete",
	["DCFLR17"] = "concrete",
	["DCFLR18"] = "concrete",
	["DCFLR19"] = "concrete",
	["DCFLR20"] = "concrete",
	["DCFLR21"] = "concrete",
	["DCFLR22"] = "concrete",
	["DCFLR23"] = "concrete",
	["DCFLR24"] = "concrete",
	["DCFLR25"] = "concrete",
	["DCZGRASS"] = "grass",
	["DSHIPF1"] = "metal",
	["DSHIPF2"] = "metal",
	["DSHIPF3"] = "metal",
	["DSHIPF4"] = "metal",
	["DSHIPF5"] = "metal",
	["DSHIPF6"] = "metal",
	["DSHIPF7"] = "metal",
	["DSHIPF8"] = "metal",
	["DSHIPF9"] = "metal",
	["DSHIPFA"] = "metal",
	["DSHIPFB"] = "metal",
	["DSHIPFC"] = "metal",
	["DSHIPFD"] = "metal",
	["DSHIPFE"] = "metal",
	["LFLRA1"] = "concrete",
	["LFLRA2"] = "concrete",
	["LFLRA3"] = "concrete",
	["LFLRB1"] = "concrete",
	["LFLRB2"] = "concrete",
	["LFLRB3"] = "concrete",
	["LFLRB4"] = "concrete",
	["LFLRC1"] = "concrete",
	["LFLRC2"] = "concrete",
	["LFLRC3"] = "concrete",
	["LFLRC4"] = "concrete",
	["LFLRD1"] = "concrete",
	["LFLRD2"] = "concrete",	
	["LFLRE1"] = "concrete",
	["LFLRE2"] = "concrete",
	["LFLRF1"] = "concrete",
	["LFLRF1B"] = "concrete",
	["LFLRF2"] = "concrete",
	["LFLRF2B"] = "concrete",
	["LFLRF3"] = "concrete",
	["LFLRF4"] = "concrete",
	["GHZBRDG1"] = "wood",
	["GHZBRDG2"] = "wood",
	["GHZBRDG3"] = "wood",
	["GHZBRDG4"] = "wood",
	["GHZFLR02"] = "wood",
	["GHZFLR07"] = "concrete",
	["GHZFLR08"] = "concrete",
	["GHZFLR09"] = "wood",
	["GHZFLR0C"] = "concrete",
	["GHZROCKF"] = "concrete",
	["GRNLITE1"] = "concrete",
	["GATE2"] = "concrete",
	["2FORTF1"] = "wood",
	["2FORTF2"] = "wood",
	["2FORTF3"] = "wood",
	["2FORTF4"] = "wood",
	["2FORTF5"] = "wood",
	["2FORTF6"] = "wood",
	["2FORTF7"] = "wood",
	["2FORTF8"] = "wood",
	["2FORTF9"] = "wood",
	["2FORTFA"] = "wood",
	["2FORTFB"] = "concrete",
	["2FORTFC"] = "concrete",
	["WHITEFLR"] = "concrete",
	["LIMEFLR"] = "concrete",
	["BLUEFLR"] = "concrete",
	["CYANFLR"] = "concrete",
	["GREENFLR"] = "concrete",
	["GREYFLR"] = "concrete",
	["GOLDFLR"] = "concrete",
	["NEOGFLR"] = "concrete",
	["ORGFLR"] = "concrete",
	["VIOFLR"] = "concrete",
	["PURFLR"] = "concrete",
	["REDFLR"] = "concrete",
	["YELFLR"] = "concrete",
	["STLBLKF1"] = "metal",
	["STLBLKF2"] = "metal",
	["STLFLR01"] = "metal",
	["STLFLR02"] = "metal",
	["HPZBLOK"] = "concrete",
	["HPZROCK"] = "concrete",
	["MARIOF1"] = "concrete",
	["MARIOF2"] = "concrete",
	["MARIOF3"] = "metal",
	["MARIOF4"] = "concrete",
	["MARIOF5"] = "concrete",
	["MARIOF5A"] = "concrete",
	["MARIOF6"] = "metal",
	["MARIOF7"] = "concrete",
	["MARIOF8"] = "concrete",
	["MARIOF9"] = "concrete",
	["MARIOF10"] = "concrete",
	["MARIOF11"] = "concrete",
	["MARIOF12"] = "concrete",
	["MARIOF13"] = "concrete",
	["MARIOF14"] = "concrete",
	["MARIOF15"] = "concrete",
	["MARIOF16"] = "concrete",
	["MARROCK1"] = "concrete",
	["MARROCK2"] = "concrete",
	["MARROCK3"] = "concrete",
	["MARROCK4"] = "concrete",
	["THWOMPFL"] = "concrete",
	["GSPECF"] = "concrete",
	["GSPECF2"] = "concrete",
	["GSPECF3"] = "concrete",
	["PSPECF"] = "concrete",
	["PSPECF2"] = "concrete",
	["PSPECF3"] = "concrete",
	["BSPECF"] = "concrete",
	["BSPECF2"] = "concrete",
	["BSPECF3"] = "concrete",
	["CSPECF"] = "concrete",
	["CSPECF2"] = "concrete",
	["CSPECF3"] = "concrete",
	["YSPECF"] = "concrete",
	["YSPECF2"] = "concrete",
	["YSPECF3"] = "concrete",
	["RSPECF"] = "concrete",
	["RSPECF2"] = "concrete",
	["RSPECF3"] = "concrete",
	["ASPECF"] = "concrete",
	["ASPECF2"] = "concrete",
	["ASPECF3"] = "concrete",
	["SFLR01"] = "concrete",
	["SFLR01B"] = "concrete",
	["SFLR02"] = "concrete",
	["SFLR02B"] = "concrete",
	["SFLR03"] = "concrete",
	["SFLR04"] = "concrete",
	["SFLR05"] = "concrete",
	["SFLR06"] = "concrete",
	["SFLR07"] = "concrete",
	["SFLR08"] = "concrete",
	["SFLR09"] = "concrete",
	["SFLR10"] = "concrete",
	["SFLR11"] = "concrete",
	["SFLR12"] = "concrete",
	["SFLR13"] = "concrete",
	["SFLR14"] = "concrete",
	["SFLR15"] = "concrete",
	["SFLR16"] = "concrete",
	["SFLR17"] = "concrete",
	["SFLR18"] = "concrete",
	["SFLR19"] = "concrete",
	["SFLR20"] = "concrete",
	["SFLR21"] = "concrete",
	["SFLR22"] = "concrete",
	["SFLR23"] = "concrete",
	["SFLR24"] = "concrete",
	["SFLR25"] = "concrete",
	["SFLR26"] = "concrete",
	["SFLR27"] = "concrete",
	["SFLR28"] = "concrete",
	["SFLR29"] = "concrete",
	["SFLR30"] = "concrete",
	["SFLR31"] = "concrete",
	["SFLR32"] = "concrete",
	["SFLR33"] = "concrete",
	["SFLR34"] = "concrete",
	["SFLR35"] = "concrete",
	["SPACEBL"] = "concrete",
	["SPACEBM"] = "concrete",
	["SPACEBS"] = "concrete",
	["SPACEGL"] = "concrete",
	["SPACEGM"] = "concrete",
	["SPACEGS"] = "concrete",
	["SPACERL"] = "concrete",
	["SPACERM"] = "concrete",
	["SPACERS"] = "concrete",
	["DSBLOCB1"] = "concrete",
	["GFZFWR01"] = "grass",
	["GFZFWR02"] = "grass",
	["THPIPEFA"] = "concrete",
	["THPIPEFB"] = "concrete",
	["THPIPEFC"] = "concrete",
	["THPIPEFD"] = "concrete",
	["BWATER01"] = "water",
	["BWATER02"] = "water",
	["BWATER03"] = "water",
	["BWATER04"] = "water",
	["BWATER05"] = "water",
	["BWATER06"] = "water",
	["BWATER07"] = "water",
	["BWATER08"] = "water",
	["BWATER09"] = "water",
	["BWATER10"] = "water",
	["BWATER11"] = "water",
	["BWATER12"] = "water",
	["BWATER13"] = "water",
	["BWATER14"] = "water",
	["BWATER15"] = "water",
	["BWATER16"] = "water",
	["FWATER1"] = "water",
	["FWATER2"] = "water",
	["FWATER3"] = "water",
	["FWATER4"] = "water",
	["FWATER5"] = "water",
	["FWATER6"] = "water",
	["FWATER7"] = "water",
	["FWATER8"] = "water",
	["FWATER9"] = "water",
	["FWATER10"] = "water",
	["FWATER11"] = "water",
	["FWATER12"] = "water",
	["FWATER13"] = "water",
	["FWATER14"] = "water",
	["FWATER15"] = "water",
	["FWATER16"] = "water",
	["CHEMG01"] = "water",
	["CHEMG02"] = "water",
	["CHEMG03"] = "water",
	["CHEMG04"] = "water",
	["CHEMG05"] = "water",
	["CHEMG06"] = "water",
	["CHEMG07"] = "water",
	["CHEMG08"] = "water",
	["CHEMG09"] = "water",
	["CHEMG10"] = "water",
	["CHEMG11"] = "water",
	["CHEMG12"] = "water",
	["CHEMG13"] = "water",
	["CHEMG14"] = "water",
	["CHEMG15"] = "water",
	["CHEMG16"] = "water",
	["GWATER01"] = "water",
	["GWATER02"] = "water",
	["GWATER03"] = "water",
	["GWATER04"] = "water",
	["GWATER05"] = "water",
	["GWATER06"] = "water",
	["GWATER07"] = "water",
	["GWATER08"] = "water",
	["GWATER09"] = "water",
	["GWATER10"] = "water",
	["GWATER11"] = "water",
	["GWATER12"] = "water",
	["GWATER13"] = "water",
	["GWATER14"] = "water",
	["GWATER15"] = "water",
	["GWATER16"] = "water",
	["GOOP01"] = "water",
	["GOOP02"] = "water",
	["GOOP03"] = "water",
	["GOOP04"] = "water",
	["GOOP05"] = "water",
	["GOOP06"] = "water",
	["GOOP07"] = "water",
	["GOOP08"] = "water",
	["GOOP09"] = "water",
	["GOOP10"] = "water",
	["GOOP11"] = "water",
	["GOOP12"] = "water",
	["GOOP13"] = "water",
	["GOOP14"] = "water",
	["GOOP15"] = "water",
	["GOOP16"] = "water",
	["LWATER1"] = "water",
	["LWATER2"] = "water",
	["LWATER3"] = "water",
	["LWATER4"] = "water",
	["LWATER5"] = "water",
	["LWATER6"] = "water",
	["LWATER7"] = "water",
	["LWATER8"] = "water",
	["LWATER9"] = "water",
	["LWATER10"] = "water",
	["LWATER11"] = "water",
	["LWATER12"] = "water",
	["LWATER13"] = "water",
	["LWATER14"] = "water",
	["LWATER15"] = "water",
	["LWATER16"] = "water",
	["TAR"] = "water",
	["OIL01"] = "water",
	["OIL02"] = "water",
	["OIL03"] = "water",
	["OIL04"] = "water",
	["OIL05"] = "water",
	["OIL06"] = "water",
	["OIL07"] = "water",
	["OIL08"] = "water",
	["OIL09"] = "water",
	["OIL10"] = "water",
	["OIL11"] = "water",
	["OIL12"] = "water",
	["OIL13"] = "water",
	["OIL14"] = "water",
	["OIL15"] = "water",
	["OIL16"] = "water",
	["LAVA1"] = "water",
	["LAVA2"] = "water",
	["LAVA3"] = "water",
	["LAVA4"] = "water",
	["RLAVA1"] = "water",
	["RLAVA2"] = "water",
	["RLAVA3"] = "water",
	["RLAVA4"] = "water",
	["RLAVA5"] = "water",
	["RLAVA6"] = "water",
	["RLAVA7"] = "water",
	["RLAVA8"] = "water",
	["SURF01"] = "water",
	["SURF02"] = "water",
	["SURF03"] = "water",
	["SURF04"] = "water",
	["SURF05"] = "water",
	["SURF06"] = "water",
	["SURF07"] = "water",
	["SURF08"] = "water",
	["WATER0"] = "water",
	["WATER1"] = "water",
	["WATER2"] = "water",
	["WATER3"] = "water",
	["WATER4"] = "water",
	["WATER5"] = "water",
	["WATER6"] = "water",
	["WATER7"] = "water",
	["SICK01"] = "water",
	["SICK02"] = "water",
	["SICK03"] = "water",
	["SICK04"] = "water",
	["SICK05"] = "water",
	["SICK06"] = "water",
	["SICK07"] = "water",
	["SICK08"] = "water",
	["SICK09"] = "water",
	["SICK10"] = "water",
	["SICK11"] = "water",
	["SICK12"] = "water",
	["SICK13"] = "water",
	["SICK14"] = "water",
	["SICK15"] = "water",
	["SICK16"] = "water",
	["HHWATR01"] = "water",
	["HHWATR02"] = "water",
	["HHWATR03"] = "water",
	["HHWATR04"] = "water",
	["HHWATR05"] = "water",
	["HHWATR06"] = "water",
	["HHWATR07"] = "water",
	["HHWATR08"] = "water",
	["HHWATR09"] = "water",
	["HHWATR10"] = "water",
	["HHWATR11"] = "water",
	["HHWATR12"] = "water",
	["HHWATR13"] = "water",
	["HHWATR14"] = "water",
	["HHWATR15"] = "water",
	["HHWATR16"] = "water",
	["CLIFF1"] = "concrete",
	["CLIFF2"] = "concrete",
	["CLIFF3"] = "concrete",
	["CLIFF4"] = "concrete",
	["CLIFF5"] = "concrete",
	["CLIFF6"] = "concrete",
	["CLIFF7"] = "concrete",
	["CLIFF8"] = "concrete",
	["CLIFF9"] = "concrete",
	["CLIFFA"] = "concrete",
	["CLIFFB"] = "concrete",
	["CLIFFC"] = "concrete",
	["CLIFFD"] = "concrete",
	["CLIFF1S"] = "concrete",
	["CLIFF2S"] = "concrete",
	["CLIFF3S"] = "concrete",
	["CLIFF4S"] = "concrete",
	["CLIFF5S"] = "concrete",
	["CLIFF6S"] = "concrete",
	["CLIFF7S"] = "concrete",
	["CLIFF8S"] = "concrete",
	["CLIFF9S"] = "concrete",
	["CLIFFAS"] = "concrete",
	["CLIFFBS"] = "concrete",
	["CLIFFCS"] = "concrete",
	["CLIFFDS"] = "concrete",
	["CLIFFE"] = "concrete",
	["CLIFFES"] = "concrete",
	["CLIFFF"] = "concrete",
	["CLIFFFS"] = "concrete",
	["CLIFFG"] = "concrete",
	["CLIFFGS"] = "concrete",
	["CLIFFH"] = "concrete",
	["CLIFFHS"] = "concrete",
	["JNGF13S"] = "concrete",
	["JNGF14S"] = "concrete",
	["JNGF15S"] = "concrete",
	["JNGF16S"] = "concrete",
	["JNGFLR01"] = "concrete",
	["JNGFLR02"] = "concrete",
	["JNGFLR03"] = "concrete",
	["JNGFLR04"] = "concrete",
	["JNGFLR05"] = "wood",
	["JNGFLR06"] = "wood",
	["JNGFLR07"] = "wood",
	["JNGFLR08"] = "wood",
	["JNGFLR09"] = "grass",
	["JNGFLR10"] = "grass",
	["JNGFLR11"] = "grass",
	["JNGFLR12"] = "grass",
	["JNGFLR13"] = "concrete",
	["JNGFLR14"] = "concrete",
	["JNGFLR15"] = "concrete",
	["JNGFLR16"] = "concrete",
	["JNGGRS01"] = "grass",
	["JNGGRS02"] = "grass",
	["JNGGRS03"] = "grass",
	["JNGGRS04"] = "grass",
	["JNGGRS05"] = "grass",
	["JNGGRS06"] = "grass",
	["JNGGRS07"] = "grass",
	["JNGGRS08"] = "grass",
	["JNGGRS09"] = "grass",
	["JNGGRS10"] = "grass",
	["JNGGRS11"] = "grass",
	["JNGGRS12"] = "grass",
	["JNGMUDF1"] = "dirt",
	["JNGMUDF2"] = "dirt",
	["JNGMUDF3"] = "dirt",
	["JNGMUDF4"] = "dirt",
	["JNGMUDF5"] = "dirt",
	["JNGRCKF1"] = "concrete",
	["JNGRCKF2"] = "concrete",
	["JNGRCKF3"] = "concrete",
	["JNGRCKF4"] = "concrete",
	["JNGWDF1"] = "wood",
	["JNGWDF1B"] = "wood",
	["JNGWDF1S"] = "wood",
	["JNGWDF2"] = "wood",
	["JNGWDF2B"] = "wood",
	["JNGWDF2S"] = "wood",
	["JNGWDF3"] = "wood",
	["JNGWDF3B"] = "wood",
	["JNGWDF3S"] = "wood",
	["JNGWDF4"] = "wood",
	["JNGWDF4B"] = "wood",
	["JNGWDF4S"] = "wood",
	["JNGWDF5"] = "wood",
	["JNGWDF6"] = "wood",
	["JNGWDF7"] = "wood",
	["JNGWDF8"] = "wood",
	["JNGWDF9"] = "wood",
	["JNGWDFA"] = "wood",
	["JNGWDFB"] = "wood",
	["JNGWDFC"] = "wood",
	["CAVEF1"] = "concrete",
	["CAVEF2"] = "concrete",
	["CAVEF3"] = "concrete",
	["CAVEF4"] = "concrete",
	["CAVEF5"] = "concrete",
	["CAVEF6"] = "concrete",
	["CAVEF7"] = "concrete",
	["CAVEF8"] = "concrete",
	["CAVEF9"] = "concrete",
	["CAVEFA"] = "concrete",
	["CAVEFB"] = "concrete",
	["XMSFLR01"] = "concrete",
	["XMSFLR02"] = "dirt",
	["XMSFLR03"] = "concrete",
	["XMSFLR04"] = "concrete",
	["XMSFLR05"] = "wood",
	["XMSFLR06"] = "wood",
	["XMSFLR07"] = "concrete",
	["XMSFLR08"] = "wood",
	["XMSFLR09"] = "wood",
	["XMSFLR10"] = "wood",
	["XMSFLR11"] = "wood",
	["XMSFLR12"] = "wood",
	["XMSFLR13"] = "wood",
	["XMSFLR14"] = "wood",
	["XMSFLR15"] = "concrete",
	["XMSFLR16"] = "wood",
	["XMSFLR17"] = "concrete",
	["XMSFLR18"] = "concrete",
	["XMSFLR19"] = "concrete",
	["XMSFLR20"] = "concrete",
	["FHZICEFL"] = "concrete",
	["FGZROKFL"] = "concrete",
	["APFLOR1"] = "metal",
	["APFLOR2"] = "metal",
	["APFLOR3"] = "metal",
	["APFLOR4"] = "metal",
	["APFLOR5"] = "metal",
	["APFLOR6"] = "metal",
	["APFLOR7"] = "metal",
	["ICEFLR0"] = "concrete",
	["ICEFLR1"] = "concrete",
	["ICEFLR2"] = "concrete",
	["ICEFLR3"] = "concrete",
	["ICEFLR3S"] = "concrete",
	["ICEFLR4"] = "concrete",
	["ICEFLR4S"] = "concrete",
	["ICEFLR5"] = "concrete",
	["ICEFLR6"] = "concrete",
	["ICEFLR7"] = "concrete",
	["ICEFLR8"] = "concrete",
	["ICEFLR9"] = "concrete",
	["ICEFLR9S"] = "concrete",
	["ICEFLRA"] = "concrete",
	["SNOW01"] = "dirt",
	["SNOW02"] = "concrete",
	["SNOW03"] = "concrete",
	["LAKEFLR1"] = "dirt",
	["LAKEFLR2"] = "dirt",
	["LAKEFLR3"] = "dirt",
	["LAKEFLR4"] = "grass",
	["LAKEFLR5"] = "concrete",
	["LAKEFLR6"] = "concrete",
	["LAKEFLR7"] = "concrete",
	["LAKEFLRD"] = "concrete",
	["LAKEFLRE"] = "concrete",
	["LAKEPIF1"] = "metal",
	["LAKEPIF2"] = "metal",
	["LAKEFLRF"] = "concrete",
	["SRB1FE1"] = "concrete",
	["SRB1FIP1"] = "concrete",
	["SRB1FKB1"] = "concrete",
	["SRB1FR1"] = "metal",
	["SRB1FRB1"] = "metal",
	["SRB1FV1"] = "concrete",
	["SRB1FV2"] = "concrete",
	["SRB1FV3"] = "concrete",
	["HPFLOOR%20"] = "concrete",
	["HPEMERAL"] = "concrete",
	["MHFL1"] = "dirt",
	["MHFL2A"] = "grass",
	["MHFL2B"] = "grass",
	["MHFL3"] = "dirt",
	["MHFL4"] = "dirt",
	["LBZFLORC"] = "concrete",
	["LBZFLOR7"] = "concrete",
	["LBZFLOR8"] = "concrete",
	["LBZFLOR9"] = "concrete",
	["LBZFLORA"] = "concrete",
	["LBZFLORB"] = "concrete",
	["LBZFLR07"] = "metal",
	["LBZFLR08"] = "metal",
	["LBZFLR09"] = "metal",
	["SCBBLKF1"] = "metal",
	["SCBFLR01"] = "metal",
	["SCBFLR02"] = "metal",
	["SCBFLR03"] = "metal",
	["SCBFLR04"] = "metal",
	["NIZF01"] = "concrete",
	["HHZGRAS1"] = "grass",
	["HHZGRAS2"] = "grass",
	["HHZF1"] = "metal",
	["BSFLR1"] = "metal",
	["BSFLR1B"] = "metal",
	["BSFLR1C"] = "metal",
	["BSFLR1D"] = "metal",
	["BSFLR1DB"] = "metal",
	["BSFLR1E"] = "metal",
	["BSFLR1F"] = "metal",
	["BSFLR2"] = "metal",
	["BSFLR2B"] = "metal",
	["BSFLR2C"] = "metal",
	["BSFLR2D"] = "metal",
	["BSFLR2DB"] = "metal",
	["BSFLR2E"] = "metal",
	["BSFLR2F"] = "metal",
	["BSFLR3"] = "metal",
	["BSFLR3B"] = "metal",
	["BSFLR3C"] = "metal",
	["BSFLR3D"] = "metal",
	["BSFLR3DB"] = "metal",
	["BSFLR3E"] = "metal",
	["BSFLR3F"] = "metal",
	["BSFLR4"] = "metal",
	["BSFLR4E"] = "metal",
	["BSFLR5"] = "metal",
	["BSFLR5B"] = "metal",
	["BSFLR5C"] = "metal",
	["BSFLR5D"] = "metal",
	["BSFLR5DB"] = "metal",
	["BSFLR5E"] = "metal",
	["BSFLR5F"] = "metal",
	["BSFLR6"] = "metal",
	["BSFLR6B"] = "metal",
	["BSFLR6C"] = "metal",
	["BSFLR6D"] = "metal",
	["BSFLR6DB"] = "metal",
	["BSFLR6E"] = "metal",
	["BSFLR6F"] = "metal",
	["SCBGRATE"] = "metal",
	["HHZCRACF"] = "concrete",
	["HHZSTNF1"] = "concrete",
	["HHZSTNF2"] = "concrete",
	["WEBBIGF"] = "grass",
	["WEBBIGF2"] = "grass",
	["WEBBIGF3"] = "grass",
	["CONCBLAK"] = "concrete",
	["CONVEY1"] = "metal",
	["CONVEY2"] = "metal",
	["TOMBNTOP"] = "concrete",
	["HHZBLAC2"] = "concrete",
	["HHZBLACK"] = "concrete",
	["~000"] = "concrete",
	["~001"] = "concrete",
	["~002"] = "concrete",
	["~003"] = "concrete",
	["~004"] = "concrete",
	["~005"] = "concrete",
	["~006"] = "concrete",
	["~007"] = "concrete",
	["~008"] = "concrete",
	["~009"] = "concrete",
	["~010"] = "concrete",
	["~011"] = "concrete",
	["~012"] = "concrete",
	["~013"] = "concrete",
	["~014"] = "concrete",
	["~015"] = "concrete",
	["~016"] = "concrete",
	["~017"] = "concrete",
	["~018"] = "concrete",
	["~019"] = "concrete",
	["~020"] = "concrete",
	["~021"] = "concrete",
	["~022"] = "concrete",
	["~023"] = "concrete",
	["~024"] = "concrete",
	["~025"] = "concrete",
	["~026"] = "concrete",
	["~027"] = "concrete",
	["~028"] = "concrete",
	["~029"] = "concrete",
	["~030"] = "concrete",
	["~031"] = "concrete",
	["~032"] = "concrete",
	["~033"] = "concrete",
	["~034"] = "concrete",
	["~035"] = "concrete",
	["~036"] = "concrete",
	["~037"] = "concrete",
	["~038"] = "concrete",
	["~039"] = "concrete",
	["~040"] = "concrete",
	["~041"] = "concrete",
	["~042"] = "concrete",
	["~043"] = "concrete",
	["~044"] = "concrete",
	["~045"] = "concrete",
	["~046"] = "concrete",
	["~047"] = "concrete",
	["~048"] = "concrete",
	["~049"] = "concrete",
	["~050"] = "concrete",
	["~051"] = "concrete",
	["~052"] = "concrete",
	["~053"] = "concrete",
	["~054"] = "concrete",
	["~055"] = "concrete",
	["~056"] = "concrete",
	["~057"] = "concrete",
	["~058"] = "concrete",
	["~059"] = "concrete",
	["~060"] = "concrete",
	["~061"] = "concrete",
	["~062"] = "concrete",
	["~063"] = "concrete",
	["~064"] = "concrete",
	["~065"] = "concrete",
	["~066"] = "concrete",
	["~067"] = "concrete",
	["~068"] = "concrete",
	["~069"] = "concrete",
	["~070"] = "concrete",
	["~071"] = "concrete",
	["~072"] = "concrete",
	["~073"] = "concrete",
	["~074"] = "concrete",
	["~075"] = "concrete",
	["~076"] = "concrete",
	["~077"] = "concrete",
	["~078"] = "concrete",
	["~079"] = "concrete",
	["~080"] = "concrete",
	["~081"] = "concrete",
	["~082"] = "concrete",
	["~083"] = "concrete",
	["~084"] = "concrete",
	["~085"] = "concrete",
	["~086"] = "concrete",
	["~087"] = "concrete",
	["~088"] = "concrete",
	["~089"] = "concrete",
	["~090"] = "concrete",
	["~091"] = "concrete",
	["~092"] = "concrete",
	["~093"] = "concrete",
	["~094"] = "concrete",
	["~095"] = "concrete",
	["~096"] = "concrete",
	["~097"] = "concrete",
	["~098"] = "concrete",
	["~099"] = "concrete",
	["~100"] = "concrete",
	["~101"] = "concrete",
	["~102"] = "concrete",
	["~103"] = "concrete",
	["~104"] = "concrete",
	["~105"] = "concrete",
	["~106"] = "concrete",
	["~107"] = "concrete",
	["~108"] = "concrete",
	["~109"] = "concrete",
	["~110"] = "concrete",
	["~111"] = "concrete",
	["~112"] = "concrete",
	["~113"] = "concrete",
	["~114"] = "concrete",
	["~115"] = "concrete",
	["~116"] = "concrete",
	["~117"] = "concrete",
	["~118"] = "concrete",
	["~119"] = "concrete",
	["~120"] = "concrete",
	["~121"] = "concrete",
	["~122"] = "concrete",
	["~123"] = "concrete",
	["~124"] = "concrete",
	["~125"] = "concrete",
	["~126"] = "concrete",
	["~127"] = "concrete",
	["~128"] = "concrete",
	["~129"] = "concrete",
	["~130"] = "concrete",
	["~131"] = "concrete",
	["~132"] = "concrete",
	["~133"] = "concrete",
	["~134"] = "concrete",
	["~135"] = "concrete",
	["~136"] = "concrete",
	["~137"] = "concrete",
	["~138"] = "concrete",
	["~139"] = "concrete",
	["~140"] = "concrete",
	["~141"] = "concrete",
	["~142"] = "concrete",
	["~143"] = "concrete",
	["~144"] = "concrete",
	["~145"] = "concrete",
	["~146"] = "concrete",
	["~147"] = "concrete",
	["~148"] = "concrete",
	["~149"] = "concrete",
	["~150"] = "concrete",
	["~151"] = "concrete",
	["~152"] = "concrete",
	["~153"] = "concrete",
	["~154"] = "concrete",
	["~155"] = "concrete",
	["~156"] = "concrete",
	["~157"] = "concrete",
	["~158"] = "concrete",
	["~159"] = "concrete",
	["~160"] = "concrete",
	["~161"] = "concrete",
	["~162"] = "concrete",
	["~163"] = "concrete",
	["~164"] = "concrete",
	["~165"] = "concrete",
	["~166"] = "concrete",
	["~167"] = "concrete",
	["~168"] = "concrete",
	["~169"] = "concrete",
	["~170"] = "concrete",
	["~171"] = "concrete",
	["~172"] = "concrete",
	["~173"] = "concrete",
	["~174"] = "concrete",
	["~175"] = "concrete",
	["~176"] = "concrete",
	["~177"] = "concrete",
	["~178"] = "concrete",
	["~179"] = "concrete",
	["~180"] = "concrete",
	["~181"] = "concrete",
	["~182"] = "concrete",
	["~183"] = "concrete",
	["~184"] = "concrete",
	["~185"] = "concrete",
	["~186"] = "concrete",
	["~187"] = "concrete",
	["~188"] = "concrete",
	["~189"] = "concrete",
	["~190"] = "concrete",
	["~191"] = "concrete",
	["~192"] = "concrete",
	["~193"] = "concrete",
	["~194"] = "concrete",
	["~195"] = "concrete",
	["~196"] = "concrete",
	["~197"] = "concrete",
	["~198"] = "concrete",
	["~199"] = "concrete",
	["~200"] = "concrete",
	["~201"] = "concrete",
	["~202"] = "concrete",
	["~203"] = "concrete",
	["~204"] = "concrete",
	["~205"] = "concrete",
	["~206"] = "concrete",
	["~207"] = "concrete",
	["~208"] = "concrete",
	["~209"] = "concrete",
	["~210"] = "concrete",
	["~211"] = "concrete",
	["~212"] = "concrete",
	["~213"] = "concrete",
	["~214"] = "concrete",
	["~215"] = "concrete",
	["~216"] = "concrete",
	["~217"] = "concrete",
	["~218"] = "concrete",
	["~219"] = "concrete",
	["~220"] = "concrete",
	["~221"] = "concrete",
	["~222"] = "concrete",
	["~223"] = "concrete",
	["~224"] = "concrete",
	["~225"] = "concrete",
	["~226"] = "concrete",
	["~227"] = "concrete",
	["~228"] = "concrete",
	["~229"] = "concrete",
	["~230"] = "concrete",
	["~231"] = "concrete",
	["~232"] = "concrete",
	["~233"] = "concrete",
	["~234"] = "concrete",
	["~235"] = "concrete",
	["~236"] = "concrete",
	["~237"] = "concrete",
	["~238"] = "concrete",
	["~239"] = "concrete",
	["~240"] = "concrete",
	["~241"] = "concrete",
	["~242"] = "concrete",
	["~243"] = "concrete",
	["~244"] = "concrete",
	["~245"] = "concrete",
	["~246"] = "concrete",
	["~247"] = "concrete",
	["~248"] = "concrete",
	["~249"] = "concrete",
	["~250"] = "concrete",
	["~251"] = "concrete",
	["~252"] = "concrete",
	["~253"] = "concrete",
	["~254"] = "concrete",
	["~255"] = "concrete",
	["BSZFLOOR"] = "grass",
	["FLOWB_04"] = "grass",
	["FLOWO_04"] = "grass",
	["FLOWP_04"] = "grass",
	["FLOWR_04"] = "grass",
	["FLOWW_04"] = "grass",
	["FLOWY_04"] = "grass",
	["FWALL_04"] = "grass",
	["FWB_04"] = "grass",
	["FWBOW_04"] = "grass",
	["FWBOY_04"] = "grass",
	["FWBP_04"] = "grass",
	["FWBPW_04"] = "grass",
	["FWBPY_04"] = "grass",
	["FWBWY_04"] = "grass",
	["FWBY_04"] = "grass",
	["FWO_04"] = "grass",
	["FWOP_04"] = "grass",
	["FWOPY_04"] = "grass",
	["FWORY_04"] = "grass",
	["FWOWY_04"] = "grass",
	["FWP_04"] = "grass",
	["FWPW_04"] = "grass",
	["FWR_04"] = "grass",
	["FWW_04"] = "grass",
	["FWWY_04"] = "grass",
	["FLBWY_02"] = "grass",
	["FLOBY_02"] = "grass",
	["FLBWY_R2"] = "grass",
	["FWBWY_02"] = "grass",
	["BSZGRASF"] = "grass",
	["FLOWO_01"] = "grass",
	["FLOWR_01"] = "grass",
	["FLOWP_01"] = "grass",
	["FLOWW_01"] = "grass",
	["FLOWB_01"] = "grass",
	["FLOWY_01"] = "grass",
	["FLOWB_02"] = "grass",
	["FLOWO_02"] = "grass",
	["FLOWP_02"] = "grass",
	["FLOWR_02"] = "grass",
	["FLOWW_02"] = "grass",
	["FLOWY_02"] = "grass",
	["FLOWG_01"] = "grass",
	["FLOWP_03"] = "grass",
	["FLOWR_03"] = "grass",
	["FLOWW_03"] = "grass",
	["FLOWB_03"] = "grass",
	["FLOWO_03"] = "grass",
	["FLOWY_03"] = "grass",
	["BSZFLR01"] = "metal",
	["BSZFLR02"] = "metal",
	["BSZFLR03"] = "concrete",
	["BSZFLR04"] = "metal",
	["AGZFLR01"] = "concrete",
	["AGZFLR02"] = "concrete",
	["BLUINSID"] = "concrete",
	["BRICK1"] = "concrete",
	["BRICK2"] = "concrete",
	["BRICK3"] = "concrete",
	["BRICK4"] = "concrete",
	["BUSTFLR"] = "concrete",
	["CARPET01"] = "dirt",
	["CARPET02"] = "dirt",
	["CARPET03"] = "dirt",
	["CARPET04"] = "dirt",
	["CARPET05"] = "dirt",
	["CARPET06"] = "dirt",
	["CARPET07"] = "dirt",
	["CARPET08"] = "dirt",
	["CARPET09"] = "dirt",
	["CARPET10"] = "dirt",
	["CARPET11"] = "dirt",
	["CARPET12"] = "dirt",
	["CARPET13"] = "dirt",
	["CARPET14"] = "dirt",
	["CASINOF1"] = "concrete",
	["CASINOF2"] = "concrete",
	["CASINOF3"] = "concrete",
	["CASINOF4"] = "concrete",
	["CATFLR02"] = "metal",
	["CATFLR03"] = "metal",
	["CATFLR04"] = "metal",
	["CEIL3_1"] = "metal",
	["CEMENT2"] = "concrete",
	["CHEKSMOL"] = "concrete",
	["CHKGRASF"] = "grass",
	["D2LAVA"] = "concrete",
	["DEM1_1"] = "concrete",
	["DEM1_2"] = "grass",
	["DEM1_3"] = "metal",
	["DEM1_5"] = "dirt",
	["DEM1_6"] = "wood",
	["DEZBLKF1"] = "metal",
	["DEZBLKF2"] = "metal",
	["DEZBLKF3"] = "metal",
	["DEZBLKF4"] = "metal",
	["DEZBLKF5"] = "metal",
	["DEZBLKF6"] = "metal",
	["DEZBLKF7"] = "metal",
	["DEZBLKF8"] = "metal",
	["DEZBLOKF"] = "metal",
	["DEZBRKF"] = "metal",
	["DFZCLD1"] = "concrete",
	["DFZCLD2"] = "concrete",
	["DFZCLD3"] = "concrete",
	["DIRT"] = "dirt",
	["DIRT1F"] = "dirt",
	["DIRT2F"] = "dirt",
	["DIRT3F"] = "dirt",
	["DIRT4F"] = "dirt",
	["DIRT5F"] = "dirt",
	["DISCO1"] = "concrete",
	["DISCO2"] = "concrete",
	["DISCO3"] = "concrete",
	["DISCO4"] = "concrete",
	["DISCOF1"] = "dirt",
	["DKLEAFLR"] = "grass",
	["DLAVA1"] = "concrete",
	["DLAVA2"] = "concrete",
	["DLAVA3"] = "concrete",
	["DLAVA4"] = "concrete",
	["DMAPIPE"] = "metal",
	["DMAPIPE2"] = "metal",
	["DPFLAT1"] = "concrete",
	["DPFLAT2"] = "concrete",
	["DPPILL2F"] = "concrete",
	["DPPILLRF"] = "concrete",
	["DPSAND"] = "dirt",
	["DPSAND2"] = "dirt",
	["EC_VINES"] = "grass",
	["EC_VINET"] = "grass",
	["ERZBLCAU"] = "metal",
	["ERZRDCAU"] = "metal",
	["ERZYLCAU"] = "metal",
	["FLAT1_2"] = "metal",
	["FLOOR0_2"] = "dirt",
	["FLOOR0_4"] = "concrete",
	["FLOOR1_2"] = "wood",
	["FLOOR1_3"] = "wood",
	["FLOOR6_1"] = "concrete",
	["FOSSIL"] = "concrete",
	["FROST01"] = "concrete",
	["FROST02"] = "concrete",
	["F_SKY1"] = "concrete",
	["GEOBMP1"] = "concrete",
	["GEOBMP1S"] = "concrete",
	["GLASS3"] = "concrete",
	["GRASS1"] = "grass",
	["GRASS2"] = "grass",
	["GRASS3"] = "grass",
	["GRASSY"] = "grass",
	["HNYLEAFF"] = "grass",
	["HONEYF"] = "concrete",
	["LFZFLR1"] = "concrete",
	["LFZFLR2"] = "grass",
	["LFZFLR3"] = "grass",
	["LFZFLR4"] = "dirt",
	["LFZFLR5"] = "dirt",
	["LIFTFLAT"] = "metal",
	["LITEB1"] = "metal",
	["LITEB2"] = "metal",
	["LITEB3"] = "metal",
	["LITEN1"] = "metal",
	["LITEN2"] = "metal",
	["LITEN3"] = "metal",
	["LITER1"] = "metal",
	["LITER2"] = "metal",
	["LITER3"] = "metal",
	["LITEY1"] = "metal",
	["LITEY2"] = "metal",
	["LITEY3"] = "metal",
	["LVASAND1"] = "concrete",
	["LVASAND2"] = "concrete",
	["MEKPIPF1"] = "metal",
	["MEKPIPF2"] = "metal",
	["MEKPIPF3"] = "metal",
	["MEKPIPF4"] = "metal",
	["MEKPIPF5"] = "metal",
	["MEKPIPF6"] = "metal",
	["MEKPIPF7"] = "metal",
	["MRNR1T1"] = "concrete",
	["MRNR1T2"] = "concrete",
	["MRNR2T1"] = "concrete",
	["MRNR2T2"] = "concrete",
	["MRNR3T1"] = "concrete",
	["MRNR3T2"] = "concrete",
	["MRNR4T1"] = "concrete",
	["MRNR4T2"] = "concrete",
	["PAZFLR01"] = "concrete",
	["PAZFLR02"] = "concrete",
	["PAZFLR03"] = "concrete",
	["PAZFLR04"] = "concrete",
	["PAZFLR05"] = "concrete",
	["PIT"] = "concrete",
	["QUIK2"] = "dirt",
	["QUIK3"] = "dirt",
	["QUIK4"] = "dirt",
	["QUIK5"] = "dirt",
	["QUIK6"] = "dirt",
	["QUIK7"] = "dirt",
	["QUIKNOAN"] = "dirt",
	["RAINBOW1"] = "concrete",
	["RAINBOW2"] = "concrete",
	["RAINBOW3"] = "concrete",
	["RAINBOW4"] = "concrete",
	["RCZCRSF1"] = "concrete",
	["RCZCRSF2"] = "concrete",
	["RCZCRSF3"] = "concrete",
	["RCZCRSF4"] = "concrete",
	["RCZFLR1"] = "concrete",
	["RCZFLR2"] = "concrete",
	["RCZFLR3"] = "concrete",
	["RCZFLR4"] = "concrete",
	["RCZFLR5"] = "concrete",
	["RCZFLR6"] = "concrete",
	["RCZFLR7"] = "concrete",
	["RCZFLR8"] = "concrete",
	["RECORD"] = "concrete",
	["ROCKBOIL"] = "concrete",
	["ROCKBOIM"] = "concrete",
	["ROCKF1"] = "concrete",
	["ROCKF2"] = "concrete",
	["ROCKF3"] = "concrete",
	["ROCKF4"] = "concrete",
	["ROCKF5"] = "concrete",
	["ROCKFLR1"] = "concrete",
	["ROCKFLR2"] = "concrete",
	["ROCKFLR3"] = "concrete",
	["ROCKFLR4"] = "concrete",
	["ROCKMF11"] = "concrete",
	["ROCKY1F"] = "concrete",
	["ROCKY2F"] = "concrete",
	["ROCKY3F"] = "concrete",
	["ROCKY4F"] = "concrete",
	["ROCKY5F"] = "concrete",
	["ROCKY6F"] = "concrete",
	["RUINS1_1"] = "concrete",
	["RUINS1_2"] = "concrete",
	["SAND"] = "dirt",
	["SANDFLR"] = "dirt",
	["SANDFLRA"] = "concrete",
	["SANDFLRB"] = "concrete",
	["SANDFLRC"] = "concrete",
	["SEGGF01"] = "concrete",
	["SEGGF02"] = "concrete",
	["SEGGF03"] = "concrete",
	["SEGGF04"] = "concrete",
	["SEGGF05"] = "concrete",
	["SFZLEAF"] = "grass",
	["SHALEF1"] = "concrete",
	["SHALEF2"] = "concrete",
	["SHROOM1"] = "dirt",
	["SHROOM2"] = "dirt",
	["SHROOM3"] = "dirt",
	["SKY1024"] = "concrete",
	["SKY1026"] = "concrete",
	["SKY1028"] = "concrete",
	["SNDPILRA"] = "concrete",
	["SPACEYL"] = "concrete",
	["SPACEYM"] = "concrete",
	["SPACEYS"] = "concrete",
	["STONE01"] = "concrete",
	["STONEF1"] = "concrete",
	["STONEF2"] = "concrete",
	["TRAPFLR"] = "metal",
	["VENT1F"] = "metal",
	["VFZFLR01"] = "grass",
	["WOODFLR"] = "wood",
	["WOODFLR2"] = "wood",
	["WOODFLR3"] = "wood",
	["WOODFLR4"] = "wood",
	["WSPECF"] = "concrete",
	["XTRMCHK"] = "concrete",
	["YLOPIPF1"] = "concrete",
	["YLOPIPF2"] = "concrete",
	["YLOPIPF3"] = "concrete",
	["YLOPIPF4"] = "concrete",
	["ZIMFLR01"] = "concrete",
	["ZIMTILE1"] = "dirt",
	["ZIMTILE2"] = "dirt",
	["ZIMTILE3"] = "dirt",
	["ZIMTILE4"] = "dirt",
	["WOODWALL"] = "wood",
	["LEGFLR01"] = "metal",
	["LEGFLR08"] = "metal",
	["LEGFLR18"] = "metal",
	["OLDCEZF3"] = "grass",
	["D2SANDV"] = "dirt",
	["DSSANDV"] = "dirt",
}

for texture, soundclass in pairs(flatsounds)
	FlatSounds[texture] = soundclass
end

local function valid(mo)
	return mo and mo.valid
end

local function reset(player)
	if player.mo and player.mo.valid
		player.lastframe = 0
		player.lastanim = nil
		player.playsound = false
		player.wasfalling = false
		player.variablesset = true
		player.groundtexture = nil
		player.lastgroundtexture = nil
	end
end

local function has_value (tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end

if not PlayerAnimInfo
	rawset(_G, "PlayerAnimInfo", {})
end

local playeraniminfo = {
	["sonic"] = {
		["runFrames"] = {0, 2},
		["walkFrames"] = {3, 7},
		["waitFrames"] = {0},
		["run"] = true,
		["walk"] = true,
		["idle"] = true,
		["wait"] = true,
		["superRun"] = false,
		["superWalk"] = true,
		["superIdle"] = true,
		["superWait"] = false
	},
	["tails"] = {
		["runFrames"] = {-1},
		["walkFrames"] = {3, 7},
		["waitFrames"] = {-1},
		["run"] = false,
		["walk"] = true,
		["idle"] = true,
		["wait"] = false,
		["superRun"] = false,
		["superWalk"] = true,
		["superIdle"] = true,
		["superWait"] = false
	},
	["knuckles"] = {
		["runFrames"] = {0, 2},
		["walkFrames"] = {3, 7},
		["waitFrames"] = {-1},
		["run"] = true,
		["walk"] = true,
		["idle"] = true,
		["wait"] = false,
		["superRun"] = true,
		["superWalk"] = true,
		["superIdle"] = true,
		["superWait"] = false
	},
	["amy"] = {
		["runFrames"] = {2, 7},
		["walkFrames"] = {3, 7},
		["waitFrames"] = {1, 3},
		["run"] = true,
		["walk"] = true,
		["idle"] = true,
		["wait"] = true,
		["superRun"] = true,
		["superWalk"] = true,
		["superIdle"] = true,
		["superWait"] = true
	},
	["fang"] = {
		["runFrames"] = {1, 4},
		["walkFrames"] = {3, 7},
		["waitFrames"] = {-1},
		["run"] = true,
		["walk"] = true,
		["idle"] = true,
		["wait"] = false,
		["superRun"] = true,
		["superWalk"] = true,
		["superIdle"] = true,
		["superWait"] = false
	},
	["metalsonic"] = {
		["runFrames"] = {-1},
		["walkFrames"] = {-1},
		["waitFrames"] = {-1},
		["run"] = false,
		["walk"] = false,
		["idle"] = true,
		["wait"] = false,
		["superRun"] = false,
		["superWalk"] = false,
		["superIdle"] = true,
		["superWait"] = false
	}
}

for skin, animinfo in pairs(playeraniminfo)
	PlayerAnimInfo[skin] = animinfo
end

addHook("PlayerThink", function(player) 
	if player.mo
		local panimInfo = PlayerAnimInfo[player.mo.skin]
		if panimInfo ~= nil
			if player.variablesset == nil
				reset(player)
			end
			player.groundtexture = GetGroundTexture(player.mo)
			if player.groundtexture == nil and player.lastgroundtexture ~= nil
				player.groundtexture = player.lastgroundtexture
			end
			local material
			local soundType
			player.playsound = false
			if P_IsObjectOnGround(player.mo)
				if not(player.wasfalling)
					if player.skidtime == 16
						player.playsound = true
						soundType = "skid"
					elseif not (player.powers[pw_carry])
						if player.mo.state == S_PLAY_RUN
							player.playsound = panimInfo["run"] and (player.powers[pw_super] == 0 or panimInfo["superRun"]) and (has_value(panimInfo["runFrames"], player.mo.frame & FF_FRAMEMASK) or has_value(panimInfo["runFrames"], player.mo.frame))
						elseif player.mo.state == S_PLAY_WALK 
							player.playsound = panimInfo["walk"] and (player.powers[pw_super] == 0 or panimInfo["superWalk"]) and (has_value(panimInfo["walkFrames"], player.mo.frame & FF_FRAMEMASK) or has_value(panimInfo["walkFrames"], player.mo.frame))
						elseif player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_EDGE
							player.playsound = panimInfo["idle"] and (player.powers[pw_super] == 0 or panimInfo["superIdle"]) and player.lastanim ~= player.panim
						elseif player.mo.state == S_PLAY_WAIT 
							player.playsound = panimInfo["wait"] and (player.powers[pw_super] == 0 or panimInfo["superWait"])  and (has_value(panimInfo["waitFrames"], player.mo.frame & FF_FRAMEMASK) or has_value(panimInfo["waitFrames"], player.mo.frame))
						end

						soundType = "steps"
						player.playsound = player.playsound and player.lastframe ~= player.mo.frame
						player.lastframe = player.mo.frame
						player.lastanim = player.panim
					end
				else
					player.wasfalling = false
					player.playsound = true
					soundType = "land"
				end
			else
				player.wasfalling = true
			end

			if player.playsound
				if not (player.mo.eflags & MFE_GOOWATER)
					material = FlatSounds[player.groundtexture]
					if material ~= nil
						player.lastgroundtexture = player.groundtexture
						local sounds = soundsList[material][soundType]
						S_StartSound(player.mo, sounds[P_RandomKey(#sounds) + 1])
					end
				end
				if (player.mo.eflags & MFE_UNDERWATER) or (player.mo.eflags & MFE_TOUCHWATER) or (player.mo.eflags & MFE_GOOWATER)
					local sounds = soundsList["water"][soundType]
					S_StartSound(player.mo, sounds[P_RandomKey(#sounds) + 1])
				end	
			end
		end
	end
end)